/******************************************************************************/
/*                                                                            */
/*                Advanced Navigation Packet Protocol Library                 */
/*              Java Language Spatial FOG Dual SDK, Version 7.0               */
/*                    Copyright 2023, Advanced Navigation                     */
/*                                                                            */
/******************************************************************************/
/*
 * Copyright (C) 2023 Advanced Navigation
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

package com.advancednavigation.anPackets;

/* GNSS Summary */
public class ANPacket66
{
	public static final int LENGTH = 40;

	public float geoidHeight;
	public float pdop;
	public float hdop;
	public float vdop;
	public float tdop;
	public int gpsUtcOffset;
	public float heading;
	public int gpsSatellites;
	public int glonassSatellites;
	public int sbasSatellites;
	public int beidouSatellites;
	public int galileoSatellites;

	public ANPacket66()
	{
	}

	public ANPacket66(ANPacket packet)
	{
		geoidHeight = TypeConversion.bytesToFloat(packet.data, 0);
		pdop = TypeConversion.bytesToFloat(packet.data, 4);
		hdop = TypeConversion.bytesToFloat(packet.data, 8);
		vdop = TypeConversion.bytesToFloat(packet.data, 12);
		tdop = TypeConversion.bytesToFloat(packet.data, 16);
		gpsUtcOffset = TypeConversion.bytesToInt32(packet.data, 20);
		heading = TypeConversion.bytesToFloat(packet.data, 24);
		gpsSatellites = packet.data[29] & 0xFF;
		glonassSatellites = packet.data[30] & 0xFF;
		beidouSatellites = packet.data[31] & 0xFF;
		galileoSatellites = packet.data[32] & 0xFF;
		sbasSatellites = packet.data[33] & 0xFF;
	}
}
